#ifndef __CONST
#define __CONST

#ifndef MM_PI
#define MM_PI 3.14159265
#endif

#define HQ    1.05456E-34
#define EL    1.60219E-19
#define K_B   1.38066E-23
#define EPSI  8.85419E-12

#define MM_E  9.1096E-31          /* Elektronenmasse */
#define MM_P  1.67265E-27         /* Protonenmasse */
#define MM_H  1.67352E-27         /* H-Atommasse */
#define MM_A  6.644E-27           /* alfa-Teilchenmasse */
#define A_B   5.291E-11           /* Bohr'scher Radius des H-Atoms */


#endif
