/*  PROGRAMM BESTIMMT DEN WERT BEI DEM DAS POTENTIAL AUF DEN MIT        */
/*  POTTEIL BESTIMMTEN TEIL DER KIN ENERGIE ABGEFALLEN IST. WENN DER    */
/*  DAZU NOTWENDIGE WERT GRER ALS GRENZMAX IST, WIRD -1               */
/*  ZURUEKGEGEBEN. DER KLEINSTE WERT, DER ZURUEKGEGEBEN WIRD IST 30     */

/*           PROGRAMM MIT VERSCHIEDENEN PARAMETERN GETESTET             */

#ifndef __GRENZE
#define __GRENZE

/* #define __TEST_GRENZE */               /* Beim Ausfuehren nur dieser */
/* #define E_I_STREUUNG  */            /* Funktion Kommentare entfernen */

#include "quer.h"
#include "setz.h"
 
				    /* Test wann Bedingung erfuellt ist */

int cutoff (TYP (*pot)(TYP x,TYP kappa),TYP a,TYP kappa,TYP potteil)
{
int i;
for (i=30;i<GRENZMAX;i++)
    {
    if ( fabs(pot(i,kappa)/potteil) < (a*a) ) return i;
    }
return -1;
}

#ifdef __TEST_GRENZE

int main (void)
{
TYP a=0.001;
TYP kappa=0.001;
TYP potteil=POTTEIL;
int gren;
int maxi=GRENZMAX;

Z=10;

gren=cutoff(pot,a,kappa,potteil);
if(gren==-1)
  {
			  /* Ausgabe, wenn der Wert grer als 1000 ist */
   printf("\n\n\n\n\n\n");
   printf("              Die eingegebenen Daten");
   printf(" ( ENERGIE und KAPPA ) wrden\n\n");   /* Verlngerungszeile */
   printf("           eine zu weite Integration verlangen");
   printf(" ( > %d Bohrradien )",maxi);
   printf("\n\n\n\n\n\n");
   printf("             Berechnung der Streuphase");
   printf(" mit einem anderen Verfahren\n\n");    /* Verlngerungszeile */
   printf("       oder maximale Integrationsgrenze in der");
   printf(" Datei ' quer.h ' ndern !\n");        /* Verlngerungszeile */
   getchar();
   getchar();
   return 0;
  }

			    /* Ausgabe des Wertes bei korrektem Ablauf  */
printf("\n\n\n\n\n\n                      DIE GRENZE IST : %d \n",gren);
getchar();
getchar();
return 0;
}

#endif
#endif
