#ifndef	__K_ENDE
#define	__K_ENDE

/* #define __TEST_K_ENDE */               /* Beim Ausfuehren nur dieser */
/* #define E_E_STREUUNG  */            /* Funktion Kommentare entfernen */

#include "header.h"
#include "quer.h"
#include "phase.c"


TYP	quer_b1(TYP	a,TYP kappa,TYP	Z_1,TYP	Z_2)
{
TYP	erg,zw1;

zw1=kappa*kappa*(kappa*kappa+4.0*a*a);
erg=16.0*MM_PI*Z_1*Z_1*Z_2*Z_2/zw1;
return erg;
}

TYP	q1_b1(TYP a,TYP	kappa,TYP Z_1,TYP Z_2)
{
TYP	erg;
TYP	zw1,zw2;

 zw1=(4.0*a*a)/(kappa*kappa);
 zw2=log(1.0+zw1)-zw1/(1.0+zw1);
 erg=(2.0*MM_PI*Z_1*Z_1*Z_2*Z_2)/(a*a*a*a)*zw2;
 return erg;
}

TYP	q1_b2(TYP a,TYP	kappa)
{
TYP	erg;
TYP	zw1,zw2;

 zw1=(4.0*a*a)/(kappa*kappa);
 zw2=(1.0+3.0/zw1-1.0/zw1/(zw1+2.0))*log(zw1+1.0)-2.5;
 erg=(4.0*MM_PI)/(a*a*a*a)*zw2;
 return erg;
}

TYP	q1_bp(TYP a,TYP	kappa,TYP polein,TYP r0)
{
TYP	erg;
TYP	zw1,zw2,zw3,hilfpol;

 hilfpol=MM_PI*MM_PI*polein*polein/(64.0*r0*r0); 
 zw1=a*r0;
 zw2=4.0/zw1+3.0/zw1/zw1+1.5/zw1/zw1/zw1+0.375/zw1/zw1/zw1/zw1;
 zw3=-zw2/exp(4.0*zw1)+0.375/zw1/zw1/zw1/zw1;
 erg=4.0*MM_PI*hilfpol*zw3;
 return erg;
}

TYP	q1_bp_desja(TYP a,TYP kappa,TYP polein,TYP r0)
{
TYP	erg;
TYP	setA,setB,setC,setD,setE;
TYP     zwi1,kr0,kr0squ,kr0cub,kr0fou;

 kr0=kappa*r0;
 kr0squ=kr0*kr0;
 kr0cub=kr0*kr0*kr0;
 kr0fou=kr0*kr0*kr0*kr0;

 setA=1.0+2.0*kr0+7.0/MM_PI/MM_PI*kr0squ+MM_PI/7.0*kr0cub;
 setB=exp(-18.0*kr0);
 setC=(1.0+22.0*kr0-11.3*kr0squ+33.0*kr0fou)/(1.0+6.0*kr0+4.7*kr0squ+2.0*kr0fou);
 setD=(1.0+28.0*kr0+13.8*kr0squ+3.2*kr0fou)/(1.0+8.0*kr0+10.0*kr0squ+kr0fou);
 setE=1.0+0.1*kr0+0.3665*kr0squ;

 zwi1=setA*setA+3.0*setB*a*r0+7.5*setC*a*a*r0*r0-3.4*setD*a*a*a*r0*r0*r0+10.6668*setE*a*a*a*a*r0*r0*r0*r0;
 erg=MM_PI*MM_PI*MM_PI*polein*polein/4.0/r0/r0/zwi1;
 return erg;
}

TYP	k_ende(TYP kappa,TYP rela_max,TYP max_max,TYP anf,TYP step)
{


FILE *dat;	 
TYP  erg;
TYP  phase[12000];
TYP  qu_u,qu_b;
TYP  zw1,zw2,rela;
TYP  zwi,mit,max;
int  l,sicher;

sicher=1;

dat=fopen("k-grenze.dat","a");
max=anf;
do{	for(l=0;l<11999;l++) phase[l]=0.0;
		for(l=0;l<10000;l++) 
	  {	phase[l]=phasen(max,l,kappa);
		if(	fabs(phase[l])<KLEIN ) l=12000;	}
	
	qu_u=0.0;
	for(l=0;l>-1;l++)
	  { 
	    if (streuung=='D' || streuung=='P'){
	    zw1=sin(phase[l]-phase[l+1])*sin(phase[l]-phase[l+1]);
	    zw2=(l+1)*zw1;
	    qu_u+=zw2;};
	    if (streuung=='E'){
	    zw1=sin(phase[l]-phase[l+2])*sin(phase[l]-phase[l+2]);
	    zw2=0.5*(l+1)*(l+2)/(2.0*l+3.0)*zw1;
	    if (l%2!=0) zw2=3.0*zw2;
	    qu_u+=zw2;}
	    if( fabs(phase[l])<5.0*KLEIN ) l=-5; 
	  }
	qu_u=(4.*MM_PI/(max*max))*qu_u;
	if (streuung=='D') qu_b=q1_b1(max,kappa,1.0,Z);
	if (streuung=='E') qu_b=q1_b2(max,kappa);
	if (streuung=='P') qu_b=q1_bp_desja(max,kappa,pol,r_0);

	zwi=fabs(qu_u-qu_b);
	mit=0.5*(qu_u+qu_b);
	rela=zwi/mit;
	fprintf(dat,"max=%.2le q_u=%.2le q_b=%.2le rela=%.1le rela_max=%.1le\n",max,qu_u,qu_b,rela,rela_max);

	if( rela<rela_max && sicher<0 )
	 { erg=max;
	   max=-step; }
	else max+=step;
	if( rela<rela_max ) sicher=-1;
	if( max>max_max ) 
	 { erg=max_max;
	   max=-step; }
  }while(max>0);
  fprintf(dat,"\n\n");
fclose(dat);  
return erg;	

}

#ifdef __TEST_K_ENDE

int	main(void)
{
TYP	erg;
TYP	kappa;

kappa=5.0e-01;
Z=1.0;
step=0.001;
setzen();

printf("   ANFANG !!!\n\n");
erg=k_ende(kappa,5.0e-01,10.0);
printf("\n k_ende :	%le\n",erg);
printf("   FERTIG !!!\n\n");

getchar();
getchar();
return 0;
}

#endif
#endif
