#ifndef	__quer
#define	__quer

#include "header.h"
#include "utilites.c"

#ifndef	MM_PI
#define	MM_PI 3.14159265358979323846
#endif

#define	GRENZMAX 20000
#define	POTTEIL	0.00001
#define	KLEIN 0.00005
#define	L_MAXI 20100

TYP	step;                /* Schrittweite im Numerowverfahren */
TYP	a_0;                                   /* Referenzlaenge */
TYP	Z;                         /* Ladung des gestreuten Ions */
TYP	eps;               /* relative Dielektrizitaetskonstante */
TYP     pol; 
TYP     r_0;
char    streuung;

#include "setz.h"     /* Setzen der Kontanten und des Potentials */
/*#include "setz.c"*/

struct ZYLFUNKT	           /* Rueckgabewerte der Funktion bessel */
{
TYP	bessel;
TYP	besabl;
TYP	neuman;
TYP	neuabl;
};

struct NUMEROW           /* Rueckgabewerte des Numerowverfahrens */
{
TYP	logabl;
int	grenze;
};

#endif
